<!DOCTYPE html>
<html>
<head>

	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>


	<title>BootStrap-flex</title>
</head>
<body>

	<div class = "container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex class to create a flex container and transform direct children into flex items</p>

		<h2>Centering elements</h2>
		<!-- d-flex will change the element into block-level containter but the columns will be inline. it will make all the child elements become"flexible" -->

		<!-- justify-content-center it will horizontally center -->

		<!-- align-items-center it will vertically center -->

		<!-- flex-column this class will display elements on top of each other -->
		<div style= "height:500px;" class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column">
			<div class="h-25 p-3 bg-success ">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>


	<h2>Flex Row</h2>
	<!-- flex-row changes how the elements display horizontally -->
		<div class="bg-dark p-3 d-flex flex-row">
				<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item A</div>
			<div class="p-3 bg-danger">Flex Item A</div>
		</div>

		<h2>Flex Row Reverse</h2>
			<div class="bg-dark p-3 d-flex flex-row-reverse">
				<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item A</div>
			<div class="p-3 bg-danger">Flex Item A</div>
		</div>


		<h2>Creating Space Between Elements</h2>
		<!-- d-md-flex class will apply flex values to table and desktop view -->

		<!-- justify-content-around add margins around the on the content -->
		<div class="p-3 bg-dark d-md-flex justify-content-around">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item A</div>
			<div class="p-3 bg-danger col-md-2">Flex Item A</div>
		</div>


		<h2>Flexbox with margin</h2>
		<!-- mr-auto class will occupy the remaining width of its parent container pushing all the other elements inline -->
		<div class="p-3 bg-dark d-flex">
			<div class="p-3 bg-success ">Flex Item A</div>
			<div class="p-3 bg-warning mr-auto">Flex Item B</div>
			<div class="p-3 bg-danger ">Flex Item C</div>
			<div class="p-3 bg-primary ">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<div class = "bg-dark p-3 d-flex">
			<div class="p-3 bg-success ">Flex Item A</div>
				<div class="d-flex justify-content-between w-25">
					<div class="p-3 bg-warning ">Flex Item B</div>
					<div class="p-3 bg-danger ">Flex Item C</div>
					<div class="p-3 bg-primary ">Flex Item D</div>
				</div>
		</div>

	</div>




<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>